<script setup lang="ts">
import { ref, onMounted, watch } from 'vue'
import BarChart from '@/components/organisms/BarChart.vue'
import { ref as fref, get, set, push, child } from 'firebase/database'
import database from '..//fireBaseConfig'
import { useElementVisibility } from '@vueuse/core'

let humongousArray: Array<Array<number>> = [[]]
const quickSortWorker = new Worker('/src/workers/quickSortWorker.ts')
const bubbleSortWorker = new Worker('/src/workers/bubbleSortWorker.ts')
const cycleSortWorker = new Worker('/src/workers/cycleSortWorker.ts')
const universalData = ref<Array<number>>([])

const chart1 = ref(null)
const chart2 = ref(null)
const chart3 = ref(null)
const chart1Visible = useElementVisibility(chart1)
const chart2Visible = useElementVisibility(chart2)
const chart3Visible = useElementVisibility(chart3)

onMounted(() => {
  //fetch data sets from firebase
  const dbRef = fref(database)
  get(child(dbRef, 'datasets'))
    .then((snapshot) => {
      if (snapshot.exists()) {
        humongousArray = Object.values(snapshot.val())
        if (humongousArray !== null || humongousArray !== undefined) {
          universalData.value = humongousArray[0]
        }
      } else {
        console.log('no data available')
      }
    })
    .catch((err) => {
      console.log(err)
    })
})

watch(universalData, (newData, oldData) => {
  chartDataQuickSort.value = newData
  chartDataBubbleSort.value = newData
  chartDataCycleSort.value = newData
  labels.value = newData
})

const chartDataQuickSort = ref<Array<number>>(universalData.value)
const chartDataBubbleSort = ref<Array<number>>(universalData.value)
const chartDataCycleSort = ref<Array<number>>(universalData.value)
const labels = ref<Array<number>>(universalData.value)
const sort = () => {
  quickSortWorker.postMessage({ array: JSON.stringify(chartDataQuickSort.value) })
  quickSortWorker.onmessage = ({ data }) => {
    chartDataQuickSort.value = data.array
  }
  bubbleSortWorker.postMessage({ array: JSON.stringify(chartDataBubbleSort.value) })
  bubbleSortWorker.onmessage = ({ data }) => {
    chartDataBubbleSort.value = data.array
  }
  cycleSortWorker.postMessage({ array: JSON.stringify(chartDataCycleSort.value) })
  cycleSortWorker.onmessage = ({ data }) => {
    chartDataCycleSort.value = data.array
  }
}

const reset = () => {
  chartDataQuickSort.value = universalData.value
  chartDataBubbleSort.value = universalData.value
  chartDataCycleSort.value = universalData.value
}

const addData = () => {
  const dataRef = fref(database, 'datasets')
  const newDataRef = push(dataRef)
  set(newDataRef, universalData)
    .then(() => {
      //success
    })
    .catch((err) => {
      console.error(err)
    })
}
</script>

<template>
  <h1>Sorting algorithms comparer</h1>
  <div id="inputContainer">
    <label for="datasets">Choose a data set: </label>

    <select
      name="datasets"
      id="datasets"
      @change="universalData = humongousArray[$event.target?.value]"
    >
      <option v-for="(arr, index) in humongousArray" :value="index" :key="index">
        Data set {{ index + 1 }} (length: {{ arr.length }} )
      </option>
    </select>
  </div>
  <div class="btns">
    <button @click="sort" class="btn">sort</button>
    <button @click="addData" v-if="false" class="btn">Add data</button>
    <button @click="reset" class="btn">reset</button>
  </div>
  <div id="chartContainer">
    <div class="chart" ref="chart1" :class="chart1Visible ? `show` : `hidden`">
      <BarChart name="Quick sort" :labels="labels" :data="chartDataQuickSort"></BarChart>
      <div class="info">
        <h2>Quick sort</h2>
        <p>
          QuickSort is een sorteeralgoritme gebaseerd op het Verdeel en heers algoritme dat een
          element als pivot kiest en de gegeven array verdeelt rond de gekozen pivot door de pivot
          op de juiste positie in de gesorteerde array te plaatsen.
        </p>
        <div class="O">
          <p>Average time complexity: nlogn</p>
          <p>Space complecity: logn</p>
        </div>
      </div>
    </div>
    <div class="chart" ref="chart2" :class="chart2Visible ? `show` : `hidden`">
      <BarChart name="Bubble sort" :labels="labels" :data="chartDataBubbleSort"></BarChart>
      <div class="info">
        <h2>Bubble sort</h2>
        <p>
          Bubble sort is een algoritme dat doorheen de array itereert en telkens 2 aangrenzende
          elementen vergelijkt en verwisseld wanneer ze in de verkeerde volgorde staan.
        </p>
        <div class="O">
          <p>Average time complexity: n&sup2;</p>
          <p>Space complecity: 1</p>
        </div>
      </div>
    </div>
    <div class="chart" ref="chart3" :class="chart3Visible ? `show` : `hidden`">
      <BarChart name="Cycle sort" :labels="labels" :data="chartDataCycleSort"></BarChart>
      <div class="info">
        <h2>Cycle sort</h2>
        <p>
          Cycle sort is een in-place sorteeralgoritme. Het basisidee achter cycle sort is om de
          input array te verdelen in meerdere cycli, waarbij elke cyclus bestaat uit elementen die
          op dezelfde positie staan in de gesorteerde output array. Het algoritme voert vervolgens
          een reeks verwisselingen uit om elk element op de juiste positie in zijn cyclus te
          plaatsen, totdat alle cycli voltooid zijn en de array gesorteerd is.
        </p>
        <div class="O">
          <p>Average time complexity: n&sup2;</p>
          <p>Space complecity: 1</p>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
@mixin btn($color, $bg) {
  width: fit-content;
  background-color: $bg;
  border: none;
  padding: 0.5rem 1.5rem;
  border-radius: 0.4rem;
  color: $color;
  font-weight: bold;
  font-size: 0.9rem;
}
#chartContainer {
  display: flex;
  flex-direction: column;
  gap: 3rem;
}
.chart {
  display: grid;
  grid-template-columns: 1fr 1fr;
  gap: 2rem;
}
.info {
  h2 {
    text-align: center;
  }
}
.btns {
  margin-top: 2rem;
  display: flex;
  gap: 2rem;
  .btn {
    @include btn(#e1e8ed, #1da1f2);
  }
  .btn:hover {
    cursor: pointer;
    animation: pulse 1.2s ease-in-out infinite;
  }
}
select {
  border: none;
  padding: 0.2rem 0.5rem;
  border-radius: 0.4rem;
}
.show {
  animation: slide-in 1s ease-out;
}
.O {
  margin-top: 2rem;
}

@keyframes slide-in {
  from {
    filter: blur(0.4rem);
    transform: translateX(-100%);
  }

  to {
    filter: blur(0);
    transform: translateX(0);
  }
}

@keyframes pulse {
  0% {
    transform: scale(1);
  }
  50% {
    transform: scale(1.2);
  }
  100% {
    transform: scale(1);
  }
}
</style>
